class SrcEngineUnsupportedError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "Src Engine Not Support {} !".format(self.buffer)


class SymbolicTrackingUnsupportedError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "Skyport SymbolicTracking Engine Not support node type {} ,\n" \
               " please inform shaobaobaoer to add model !".format(
            self.buffer)


class ExtractionEngineNotFindError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return self.buffer


class SinkLocateFailError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "Sink locate fail , get node  {} ,\n" \
               " please inform shaobaobaoer to recheck !".format(
            self.buffer)


class SinkNotExistError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "Sink not exist on this version ! Get \n {} ".format(
            self.buffer)


class NodeTypeNotSupportError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "node type not support , the node is  {} ,\n" \
               " please inform shaobaobaoer to add type !".format(
            self.buffer)


class CFGTraversalNotSupportError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "cfg traversal not support such type, the node is  {} ,\n" \
               " please inform shaobaobaoer to add type !".format(
            self.buffer)


class PureCFGFirstNodeLocateError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "Pure CFG Type Detected but fail to locate first node  {} ,\n" \
               " please inform shaobaobaoer to debug !".format(
            self.buffer)


class Py2neoVersionError(Exception):
    def __str__(self):
        return "Only support py2neo version 4.3.0 and 2021.1.1"


class Neo4jEmptyError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return "neo4j is empty   {} ,\n" \
               " please inform wzw to check out  !".format(
            self.buffer)


class Neo4jInitFormatError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return f"Init Neo4j got input format error , the init option should be Dict or str ," \
               f" which owes special format , or neo4j.graph object , \ngot {self.buffer} instead"


class Neo4jNodeListIndexError(Exception):
    def __init__(self, buffer, index):
        self.buffer = buffer
        self.index = index

    def __str__(self):
        return f"[!] Node List Index {self.index} error \n Get input node {self.buffer}"


class BackwardSlicerTraverseError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return f"[!] BackwardSlicerTraverseError {self.buffer} !" \
               f" please add this point to the case always fault and catch "

class Neo4jQuickCodeGenerationError(Exception):
    def __init__(self, buffer):
        self.buffer = buffer

    def __str__(self):
        return f'[!] {self.buffer} not implement; \n Please import shaobaobaoer to fix bugs'

