import logging
import os
from typing import List
import re

import Levenshtein


class StringMatcher(object):
    @staticmethod
    def match_best_similar_str(org_str: str, given: List[str], method="jaro") -> str:
        score_vector = [Levenshtein.jaro(org_str, i) for i in given]
        return given[score_vector.index(max(score_vector))]

    @staticmethod
    def match_best_similar_str_index(org_str: str, given: List[str], method="jaro") -> int:
        score_vector = [Levenshtein.jaro(org_str, i) for i in given]
        return score_vector.index(max(score_vector))

    @staticmethod
    def similarity_array(org_str: str, given: List[str], method="jaro") -> List[int]:
        score_vector = [Levenshtein.jaro(org_str, i) for i in given]
        return score_vector
