import logging

logger = logging.getLogger(__name__)


class SortWrapper(object):
    """
    Sort result of List[py2neo.Node] , the return of the function must be iter

    """

    def __call__(self, func):
        def wrapper(*args, **kwargs):
            res = func(*args, **kwargs)
            res.sort(key=lambda node: node['id'] if 'id' in node.keys() else node.identity, reverse=False)
            return res
        return wrapper


class UnionWrapper(object):
    """
    Union result into list

    """
    def __call__(self, func, ):
        def wrapper(*args, **kwargs):
            res = func(*args, **kwargs)
            return list(set(res))

        return wrapper


class DeprecatedWrapper(object):
    """
    Deprecate Wrapper

    """
    def __call__(self, func):
        def wrapper(*args, **kwargs):
            logger.warning(
                "calling Deprecated function " + func.__str__() + "the function will be removed sooner or later")
            return func(*args, **kwargs)
        return wrapper
